classification
Title: Travis CI fail on backports: pyvenv not installed
Type: Stage: resolved
Components: Tests Versions: Python 3.9
process
Status: closed Resolution: fixed
Dependencies: Superseder:
Assigned To: Nosy List: __Vano, larry, methane, ned.deily, pablogsal, vstinner
Priority: normal Keywords: patch

Created on 2019-12-13 10:28 by vstinner, last changed 2020-06-12 14:46 by larry. This issue is now closed.

Pull Requests
URL Status Linked Edit
PR 17602 merged methane, 2019-12-14 10:51
PR 17603 merged methane, 2019-12-14 13:37
PR 17604 merged methane, 2019-12-14 13:42
PR 17605 merged methane, 2019-12-14 13:44
PR 17622 merged methane, 2019-12-16 07:13
PR 17623 merged methane, 2019-12-16 07:31
Messages (13)
msg358325 - (view) Author: STINNER Victor (vstinner) * (Python committer) Date: 2019-12-13 10:28
Example of failure of a backport from 3.8 to 3.7, PR 17577:
https://github.com/python/cpython/pull/17577

"""
$ python --version

Python 3.6.9

$ pip --version

pip 19.3.1 from /home/travis/virtualenv/python3.6.9/lib/python3.6/site-packages/pip (python 3.6)
before_install.1

0.00s$ set -e

$ pyenv global 3.7.1

pyenv: version `3.7.1' not installed
"""

Travis CI logs:
https://travis-ci.org/python/cpython/jobs/624160244

Thread on python-dev:
https://mail.python.org/archives/list/python-dev@python.org/thread/YCTLWAYIC44YTVGNN4EDLWKMER2LAPDA/
msg358389 - (view) Author: Inada Naoki (methane) * (Python committer) Date: 2019-12-14 11:10
New changeset 94d2c8df1a7657015a2fcdb4c4d43392f91f8348 by Inada Naoki in branch 'master':
bpo-39035: travis: Don't use beta group (GH-17602)
https://github.com/python/cpython/commit/94d2c8df1a7657015a2fcdb4c4d43392f91f8348
msg358390 - (view) Author: Inada Naoki (methane) * (Python committer) Date: 2019-12-14 14:01
New changeset 5c5d8f63d7d235e557ad20e7d722b22772681759 by Inada Naoki in branch '3.8':
bpo-39035: travis: Don't use beta group (GH-17603)
https://github.com/python/cpython/commit/5c5d8f63d7d235e557ad20e7d722b22772681759
msg358391 - (view) Author: Inada Naoki (methane) * (Python committer) Date: 2019-12-14 14:02
New changeset be7489cb43e25b6d8bfa077589c18cc0a2367efd by Inada Naoki in branch '3.7':
bpo-39035: travis: Don't use beta group (GH-17604)
https://github.com/python/cpython/commit/be7489cb43e25b6d8bfa077589c18cc0a2367efd
msg358392 - (view) Author: Inada Naoki (methane) * (Python committer) Date: 2019-12-14 14:02
New changeset de4481339dec395d70e350aa2e22d7990d2b3635 by Inada Naoki in branch '2.7':
bpo-39035: travis: Don't use beta group (GH-17605)
https://github.com/python/cpython/commit/de4481339dec395d70e350aa2e22d7990d2b3635
msg358394 - (view) Author: STINNER Victor (vstinner) * (Python committer) Date: 2019-12-14 14:59
INADA-san: do you want to close this issue since you pushed changes, or do you prefer to wait to see if it's issue is fixed before closing it? (wait a few days and look at Travis CI jobs)

3.5 uses:

language: c
dist: trusty
sudo: false
group: beta

3.6 uses:

language: c
dist: trusty
sudo: false
group: beta

These branches still get pull requests for security fixes. Maybe it's worth it to also update these branches? Maybe even upgrade them to Ubuntu Xenial?
msg358401 - (view) Author: Ivan Pozdeev (__Vano) Date: 2019-12-14 19:52
I already diagnosed this in https://mail.python.org/archives/list/python-dev@python.org/message/3Z4FNPEFTFTYDX6RYOQ54UKOVLQAWUEU/:

* https://travis-ci.org/python/cpython/jobs/616384134 looks for `pythonX.Y` but doesn't account for the fact that it could be Pyenv's stub
* https://travis-ci.org/python/cpython/builds/616384157 is trying to use Python version(s) that are not guaranteed to be preinstalled in the VM for all `language:`s.

I could fix this but I need to know what the hard requirements are to pick an optimal configuration.

* Is the (preinstalled only for `language: c`) `clang 7.0.0` required? Would 3.4-4.0 (available from xenial distro) do?
* Is `xenial` required? Would `bionic` do? In bionic, clang 7 is available from distro.
* Which Python version needs to be preinstalled? Tools/ssl/multissltests.py says it's supposed to be compatible with 2.7 and 3.4-3.7. Options are, by decreasing "sum of flexibility+reliability":
  * use 3.5.1 or 2.7.12 from distro
  * hard require `language:python; python: 3.7` (then we cannot use custom `clang`)
  * use another pyenv-preinstalled version (there are also 3.6 and 2.7 that are supposed to be preinstalled but there might be none)
msg358402 - (view) Author: Ivan Pozdeev (__Vano) Date: 2019-12-14 19:56
> New changeset 94d2c8df1a7657015a2fcdb4c4d43392f91f8348 by Inada Naoki in branch 'master':
bpo-39035: travis: Don't use beta group (GH-17602)

> INADA-san: do you want to close this issue since you pushed changes?

This may actually fix the problem.

`group: beta` is undocumented. It was required long ago once to try out a new feature but I've absolutely no idea what it does (and if it does anything) now. It's quite possible that it can give us some beta unsupported VM image.
msg358405 - (view) Author: Ivan Pozdeev (__Vano) Date: 2019-12-14 20:06
While we are at it, shall we enable build config validation (https://docs.travis-ci.com/user/build-config-validation)?

It would produce warnings for outdated keys like this.
msg358525 - (view) Author: Ned Deily (ned.deily) * (Python committer) Date: 2019-12-16 23:20
New changeset 7699281b72b862797a89fcad004da8f58e93c800 by Ned Deily (Inada Naoki) in branch '3.6':
bpo-39035: travis: Update image to xenial (GH-17622)
https://github.com/python/cpython/commit/7699281b72b862797a89fcad004da8f58e93c800
msg358650 - (view) Author: Ned Deily (ned.deily) * (Python committer) Date: 2019-12-19 01:50
New changeset 9af497419540cdb4659927e66c67d861c5ea48c2 by Ned Deily (Inada Naoki) in branch '3.7':
bpo-39035: travis: Don't use beta group (GH-17604)
https://github.com/python/cpython/commit/9af497419540cdb4659927e66c67d861c5ea48c2
msg360606 - (view) Author: STINNER Victor (vstinner) * (Python committer) Date: 2020-01-24 10:31
I didn't notice the error in the last days, so I close the issue.

I would be nice to merge PR 17623, but that can be done later (by Larry Hastings, the 3.5 release manager).
msg371380 - (view) Author: Larry Hastings (larry) * (Python committer) Date: 2020-06-12 14:46
New changeset f88b578949a034f511dd1b4c1c161351b3ee0db8 by Inada Naoki in branch '3.5':
bpo-39035: travis: Update image to xenial (#17623)
https://github.com/python/cpython/commit/f88b578949a034f511dd1b4c1c161351b3ee0db8
History
Date User Action Args
2020-06-12 14:46:51larrysetnosy: + larry
messages: + msg371380
2020-01-24 10:31:52vstinnersetstatus: open -> closed
resolution: fixed
messages: + msg360606

stage: patch review -> resolved
2019-12-19 01:50:09ned.deilysetmessages: + msg358650
2019-12-16 23:20:47ned.deilysetnosy: + ned.deily
messages: + msg358525
2019-12-16 07:31:11methanesetpull_requests: + pull_request17093
2019-12-16 07:13:16methanesetpull_requests: + pull_request17092
2019-12-14 20:06:03__Vanosetmessages: + msg358405
2019-12-14 19:56:55__Vanosetmessages: + msg358402
2019-12-14 19:52:06__Vanosetnosy: + __Vano
messages: + msg358401
2019-12-14 14:59:41vstinnersetmessages: + msg358394
2019-12-14 14:02:58methanesetmessages: + msg358392
2019-12-14 14:02:23methanesetmessages: + msg358391
2019-12-14 14:01:59methanesetmessages: + msg358390
2019-12-14 13:44:17methanesetpull_requests: + pull_request17074
2019-12-14 13:42:45methanesetpull_requests: + pull_request17073
2019-12-14 13:37:25methanesetpull_requests: + pull_request17072
2019-12-14 11:10:18methanesetmessages: + msg358389
2019-12-14 10:51:19methanesetkeywords: + patch
stage: patch review
pull_requests: + pull_request17071
2019-12-13 10:28:51vstinnercreate